package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PapRiwayatTumbuhKembangService;
import com.jasamedika.medifirst2000.util.DateUtil;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.PapRiwayatTumbuhKembangVO;

/**
 * Controller class for PapRiwayatTumbuhKembangController
 * 
 * @author Askur
 */
@RestController
@RequestMapping("/riwayat-tumbuh-kembang")
@JsonIgnoreProperties(ignoreUnknown = true) 
public class PapRiwayatTumbuhKembangController extends LocaleController<PapRiwayatTumbuhKembangVO> implements
		IBaseRestController<PapRiwayatTumbuhKembangVO> {
	
	private static final Logger LOGGER = LoggerFactory.getLogger(PapRiwayatTumbuhKembangController.class);

	@Autowired
	private PapRiwayatTumbuhKembangService papRiwayatTumbuhKembangService;

	@RequestMapping(value = "/save-riwayat-tumbuh-kembang", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> save(@Valid @RequestBody PapRiwayatTumbuhKembangVO vo,HttpServletRequest request) {
		try {
			Map<String,Object> result = papRiwayatTumbuhKembangService.addRiwayatTumbuhKembang(vo);
			if (null != result){
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS, request));
				return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			} else{
				Map<String, String> headerMessageCustom = new HashMap<>();
				headerMessageCustom.put("label-success", "Pasien belum melakukan pendaftaran");
				return RestUtil.getJsonResponse(result, HttpStatus.CREATED, headerMessageCustom);
			}
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add Pasien", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add Pasien", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}

	@RequestMapping(value = "/find-noCm-and-tglInput/", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> findByNoCmAndTglInput(@RequestParam(value = "noCm", required = false) String noCm,
			@RequestParam(value = "tglInput", required = false) String tglInput,HttpServletRequest request) {
		Map<String,Object> result = papRiwayatTumbuhKembangService.findByNoCmAndTglInput(noCm, DateUtil.toDate(tglInput));
		Boolean dataFound=new Boolean((boolean) result.get("dataFound"));
		if(dataFound){
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
		}else{
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_ERROR,getMessage(MessageResource.LABEL_ERROR,request ));
		}

		return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
	}

	@RequestMapping(value = "/find-pasien-by-noCm/{noCm}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> findPasien(@PathVariable("noCm") String noCm,HttpServletRequest request) {
		Map<String,Object> result = papRiwayatTumbuhKembangService.findPasienByNoCm(noCm);
		Boolean dataFound=new Boolean((boolean) result.get("dataFound"));
		if(dataFound){
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
		}else{
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_ERROR,getMessage(MessageResource.LABEL_ERROR,request ));
		}

		return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
	}

	@Override
	public ResponseEntity<Collection<PapRiwayatTumbuhKembangVO>> getAllVOWithQueryString(HttpServletRequest request,
			Integer page, Integer limit, String sort, String dir) {
		return null;
	}

	@Override
	public ResponseEntity<PapRiwayatTumbuhKembangVO> getVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<String> addVO(PapRiwayatTumbuhKembangVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> editVO(PapRiwayatTumbuhKembangVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<List<PapRiwayatTumbuhKembangVO>> getAllVO() {
		return null;
	}

	
}
